{
 ************************************************************************************************************
 *                                                                                                          *
 *  AUTO-RECOVER NOTICE: This file was automatically recovered from an earlier Propeller Tool session.      *
 *                                                                                                          *
 *  ORIGINAL FOLDER:     C:\...\Nyan_Cat_Done - Archive  [Date 2011.12.03  Time 00.40]\New folder\          *
 *  TIME AUTO-SAVED:     6 minutes ago (2/17/2012 2:54:56 PM)                                               *
 *                                                                                                          *
 *  OPTIONS:             1)  RESTORE THIS FILE by deleting these comments and selecting File -> Save.       *
 *                           The existing file in the original folder will be replaced by this one.         *
 *                                                                                                          *
 *                           -- OR --                                                                       *
 *                                                                                                          *
 *                       2)  IGNORE THIS FILE by closing it without saving.                                 *
 *                           This file will be discarded and the original will be left intact.              *
 *                                                                                                          *
 ************************************************************************************************************
.}

var
'x location
byte xs
'y location
byte ys
'variable color from ram will be stored in
byte CN
byte CNA



CON
  ' Set up the processor clock in the standard way for 80MHz
  _XINFREQ = 5_000_000 + 0000
  _CLKMODE = XTAL1 + PLL16X

CON
 
  LEFT_AUDIO  = 11
  RIGHT_AUDIO = 10
  SCREEN_WIDTH=160
  SCREEN_HEIGHT=96
  NUM_COLORS=256
  _STACK=1000

'pin out to sram
 SI  =19
 SO  =18
 clk =17
 CS  =16
 'a binary number for the color to load to ram



OBJ
   tv : "03_NTSC4x2"            'Eric ball 8bpp driver 
   gr : "09_8bppgraphics"       'Doug Dingus basic PASM graphics COG
   'ram : "sram"
'  retronitus : "Retronitus"
   
PUB main | i, j, k, l, anim

  tv.start( @i_ptr )
  gr.start( @cmd )
  '.start(-1, 16, 17, 18, 19, -1)
  
  i_width := 40
  i_height := 96
  i_lines := 411                ' 4:3 = 144/7 * i_width
  i_pin := 12                   ' Demoboard
  i_tint := 0 
  i_ptr := @colors
  i_tint := 20

  setscreen(@colors, 80*96)  'This sets screen buffer and size for graphics cog.
   CNA := 11011011   

  DIRA[clk]~~
  DIRA[SO]~
  DIRA[CS]~~ 
  DIRA[SI]~~

  
  OUTA[CS]~~  
  OUTA[CS]~

  'loops to load sram with a number
  'command to start a write 00000010
      repeat 6
         OUTA[clk]~
         OUTA[SI]~
         OUTA[clk]~~
      OUTA[clk]~
      OUTA[SI]~~
      OUTA[clk]~~ 
      OUTA[clk]~
      OUTA[SI]~
      OUTA[clk]~~ 
 '16 bit address 
      repeat 16
         OUTA[clk]~~
         OUTA[SI]:=0
         OUTA[clk]~
' fill 8Kbyte ram with one number
      repeat 5000
        repeat 8 
         OUTA[clk]~
         CNA := (CNA << 1)
         OUTA[SI] := cna
         OUTA[clk]~~
        CNA := 11011011

     OUTA[CS]~~
     OUTA[clk]~      
     OUTA[clk]~~
     OUTA[clk]~      

     OUTA[CS]~  


        
 'a loop to set reading starting at first address
 
      repeat 6
         OUTA[clk]~
         OUTA[SI]~
         OUTA[clk]~~
      repeat 2
         OUTA[clk]~
         OUTA[SI]~~
         OUTA[clk]~~    
      repeat 16
         OUTA[clk]~
         OUTA[SI] := 0
         OUTA[clk]~~

     clear(0)                          
'loop to read ram and plot a point

repeat      
   repeat  xs from 1 to 100
      repeat ys from 1 to 80
         repeat 8
           OUTA[clk]~
           CN := INA[SO]
           CN := (CN << 1)
           OUTA[clk]~~
         plot (xs,ys,cn)
         
   repeat while i_blanking == 0



PUB   setscreen(A, B)
      'This sets a couple of global variables related to the graphics screen
      scraddr := A
      scrsize := B
      
                                            '
PUB  clear(color)                   'Quick interface to the PASM COG
      arg1 := scraddr
      arg2 := scrsize
      arg3 := color
      cmd := 01
      repeat until cmd == 0

PUB   plot(x, y, color)
      arg1 := scraddr
      arg2 := x + (y << 8)
      arg3 := color
      cmd := 03
      repeat until cmd == 0

PUB   bitplot(x, y, trans, imagemap)
      arg1 := scraddr
      arg2 := x + (y << 8)
      arg3 := trans
      arg4 := imagemap
      cmd := 02
      repeat until cmd == 0

PUB   fill(x, y, color, xsize, ysize)
      arg1 := scraddr
      arg2 := x + (y << 8)
      arg3 := color
      arg4 := xsize + (ysize << 8)
      cmd := 04
      repeat until cmd == 0

 


DAT
colors      BYTE  $05[160*96]      'The bitmap buffer


DAT

cmd           long 0     'current command, 0 = done / ready
arg1          long 0     'mailbox parameters 
arg2          long 0
arg3          long 0
arg4          long 0

scraddr       long 0    'address of screen buffer target
scrsize       long 0    'size of screen buffer target

DAT

' NTSC4x input parameters - 6 contiguous longs, reloaded each frame
i_ptr          long 0   ' pointer to screen (bytes), 0 = inactive
i_width        long 0   ' number of longs (max 48)
i_height       long 0   ' number of rows (max i_lines, does not need to be integer multiple)
i_lines        long 0   ' number of active lines (max 481, 4:3 = 144/7 * i_width)
i_pin          long 0   ' i_pin = LSB, i_pin+2 = MSB, must be divisible by 4
i_tint         long 0   ' tint correction
i_blanking     long 0   ' Vertical blank flag for syncronized screen drawing  opengeek@gmail.com
                        ' Note: NTSC4x input parameters not validated, minimum clockspeed 35.8MHz -- a bit higher now with blank
                        ' flag addition.  40Mhz maybe.